%%%%

%%%%
% z=f(x,y) is the equation of an optical surface
% One wants to act on this surface as if one were polisihing it.
% A click @ r0 on the disk will result in adding a know function to z.
% eg zmax(0,hmax-RR*sqrt(r_r0))
%%
%% also the fluctuation within this effective size should be decreased by
%% some small factor, 0.7 or so.

%%%%%%%%%%%%%%%%%%%%%% FIZEAU PARAMETERS
%%%%%%%%%%%%%%%%%%%%%%
lambda=0.505;  %micron
zref=200;
n=1.5;
anglemax=0.12; anglediaph=0.02
N_angles=121;
%theta_S=linspace(0, anglemax, N_angles);
theta_S=sqrt(linspace(0, anglemax^2, N_angles));
NCENTRE=min(find(theta_S>anglediaph))-1;%%%Circle radius (diaph) for better fringe vision configuration 0.02 rad
NCENTRE=max(NCENTRE,2);
XA=[-127:128] ; YA=[-127:128];
[XXA,YYA]=meshgrid(XA,YA);
r_A=(max(theta_S)/128)*sqrt((XXA).^2+(YYA).^2);
%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%% FIZEAU PARAMETERS END

figdisk=3;
figpersp=11;
NND=128; NND2=NND*NND;
z=zeros(NND);
DIAM=50;%mm%=xmax=ymax;% diameter of disk;
x=linspace(0,DIAM,NND);y=x;
[xx,yy]=meshgrid(x,y);
r=sqrt((xx-0.5*DIAM).^2+(yy-0.5*DIAM).^2);
Centre=0.5*[DIAM DIAM];
rclic=Centre;

kspec=zeros(NND);
NSPEC=6;
kspec(1:NSPEC,1:NSPEC)=randn(NSPEC)*exp(i*randn(NSPEC))*NND^2;
z=z+(r<0.5*DIAM).*(1e-5*abs(ifft2(kspec)).^2+1.0);   %%%%%% DEFINITION OF Z
HMAX=0.02;  RR2=12^2;
%%%RR=HMAX/10^2;  %%%  height of "polishing" and radius such that it stops (delta-z->0) at 20 microns from clic
while norm(rclic-Centre) <= 0.5*DIAM
figure(figdisk);
hha=imagesc([0 DIAM],[0 DIAM],z,[0 1.5]);hc=colorbar;
ha=get(hha,'parent');
axis([0 DIAM 0 DIAM]);axis('equal');
xlabel('x(mm)');ylabel('y (mm)');
title('carte de z               echelle de couleur en micron');
set(ha,'fontsize',12);set(hc,'fontsize',12);
 [rclic(1),rclic(2),button]=ginput(1);
 disp(['button =' num2str(button)])
rr02=(xx-rclic(1)).^2+(yy-rclic(2)).^2;
nnx=find(abs(x-rclic(1)+eps)<DIAM/NND/2    );nny=find(abs(y-rclic(2)+eps)<DIAM/NND/2    );
%ztarg=HMAX-RR*rr02;
%ztarg=HMAX*exp(-rr02/RR2);
%zut=find((ztarg>=0)&r<0.5*DIAM);
zut=find((exp(-rr02/RR2)>=1e-2)&r<0.5*DIAM);%
%zut=find((ztarg>=1e-3)&r<0.5*DIAM);
%z=z+(r<0.5*DIAM).*max(0,HMAX-RR*rr02);
%size(dz(zut))
%size(ztarg(zut))
%dz(zut)=ztarg(zut)-(z(zut)-z(nnx,nny));
dz(zut)=z(zut)-mean(z(zut));
%dz(zut)=ztarg(zut)-(z(zut)-mean(z(zut)));
%%%%%%%%%%%%%%%% SURFACE POLISHING
if button==1
z(zut)=z(zut)-0.25*dz(zut).'.*(exp(-rr02(zut)/RR2));
elseif button==3;
    z(zut)=z(zut)+0.55*dz(zut).'.*(exp(-rr02(zut)/RR2));
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%% FIZEAU
%delta(1:N_angles,1:NND2)=2*n*cos(theta_S.'/n)*(zref-z(:));
%p=(2*n/lambda)*cos(theta_S.'/n)*(zref-z(:)');
Ip=1+cos((2*pi*2*n/lambda)*cos(theta_S.'/n)*(zref-z(:)'));  %%% noter z(:) pour passer lamatrice  en 1:NND2;
Ip_infiniteconj=mean(Ip(:, r(:)<0.5*DIAM),2);%%mean of each column, indexed by first index of p : angles
Ip_imageconj=reshape(mean(Ip),NND,NND);%%%%mean of each row, indexed by 2nd index of p : positions
Ip_imageconjC=reshape(mean(Ip(1:NCENTRE,:,:)),NND,NND);%%%%mean of each row, indexed by 2nd index of p : positions

if 1>0; %%% test of role of these plots
    figure(4);
    %%%%%%
    subplot(2,1,1);cla;
    imagesc(x,y,Ip_imageconj,[-0.05 2]);colormap('gray')
    ht=title('diaphragme source ouvert');set(ht,'fontsize',12);
    subplot(2,1,2);cla;
    imagesc(x,y,Ip_imageconjC,[-0.05 2]);colormap('gray')
    ht=title('diaphragme ferm');set(ht,'fontsize',12);
end;
if 1>0;
    figure(5);
    cla;
    %%%%%%   
    Screen_infinity=reshape(interp1(theta_S,Ip_infiniteconj,r_A(:)) ,256,256);
    imagesc([-anglemax anglemax],[anglemax -anglemax],Screen_infinity,[-0.05 2]);colormap('gray');
    hold on;
    ht=title('vision  l''infini : anneaux');set(ht,'fontsize',12);
    ccos=cos(linspace(0,2*pi,64)) ;
    ssin=sin(linspace(0,2*pi,64));
    plot(anglediaph*ccos, anglediaph*ssin,'m.');
    hold off;
    xlabel('angle suivant x');ylabel('angle suivant y');
end;
%figure(figdisk);

end;


