% Teintes de Newton (et non franges comme le dit le nom du prigramme
% programme fait par H. Benisty , IOTA
% 24 Nov 2004
% Cession et usage par des entreprises ou des collectivits interdits
% Sauf accord express.
%
% Ce programme est issue du prcdent sur les
% franges du coin d'air avec source a distance finie , qui tait comment
% ainsi :
%
%%%%%%%%%%%%%%%%%%%%%%%%
%  on definit dans leplan de figure (x horizontal, y vertical) deux plans P1 P2, une source S et l'image de cette
%  source dans les deux plans puis on calcule le
%  lieu des differences de marches egaux a
%  des multiples entiers de lambda.
% les deux potentiometres de part et d'autre agissent sur le miroir mobile
% le troisieme agit surl'entendue de lasource, obtenue par une fonction
% rand (random)
%  =>tout est calcul en microns
%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Les franges de Netwon sont calcules en ne retenant que la ligne y=0, le
% calcul du reste est inutile, et n'est qu'un reste de l'ancien programme
% de simulation du coin d'air  franges_coin_3potar.m
%
%Les parties qu'on pourrait ainsi minimiser sont indique par le commentaire ($)
% avec suggestion de ce qu remplacerait ( faire par les courageux, merci
% de me retourner le rsultat
%  henri.benisty@iota.u-psud.fr


%lambda
clear
format compact

%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%
%%%  CONFIGURATION BOARD
%%%% Window sizes, line 50-54  calculated for rather big screens (1024*768?)

lambda=0.5;%microns
lambdas=linspace(0.40,0.69,2*38);lambda=mean(lambdas);%%% jeux de longueurs d'onde dans le visible
sc=100;%20;%scale of figure will be 1 to 4*sc  along X / 8*sc along Y
N=400;%discretization along both axis, N on X, 2N on y
plp=[0 4*sc -8*sc 8*sc]%[0 4*sc -4*sc 4*sc]; %fringe plot position ; in the following "pl" is there for all related variables
        %%%%mirror initial settings
y22=1;
x22=plp(2);
x12=plp(1);
y12=-1;
        %%%%%%%
sourcerand=0;%% (now suppressed ) extension of random positon of source around fixed value
phasedegre=0;%% extra phase at origin (constant dephasing between two mirrors, usually 0 or 180)
Ns=30;Nss=0;%%%to count sources as they accumulate, plot the Ns last
figure(2);clf%%% FOR THE MAIN PLOT  
set(gcf,'position',[750 360 420 360]);
figure(3);clf   %%FOR EXTRA PLOTs
set(gcf,'position',[140 35 584 648]);
figure(4);clf
set(gcf,'position',[750 30 420 240]);
%%% and normalize Itot when insufficient Nss
%Ns=80;% max number of source kept in buffer length(xs);
%Nss=0; % present number of sources (if <Ns)
%%Ns see below%%

%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%

Itot=zeros(2*N,N);
Imax=0; %to help normalize in all cases...
xss=[];yss=[];

%plp=[0 4*sc -4*sc 4*sc]; %fringe plot position ; in the following "pl" is there for all related variables
plwx=plp(2)-plp(1);plwy=plp(4)-plp(3);%%x and y width
Sx=linspace(plp(1),plp(2),N);
Sy=linspace(plp(3),plp(4),2*N);
[X Y]=meshgrid(Sx,Sy); % ($) c'est trop grand


%%%%essai de potentiomtre
%clear poty
hf2=figure(2);
clf;
axis([plp(1)-plwx plp(2)+plwx plp(3)-plwy/15 plp(4)+plwy/5]);hold on;
%%%%for the mirror plot :
SSx=[plp(1)-plwx,plp(2)+plwx];

%% mirror 1 : not moving (but the prgm keeps same maths for both mirrors)
alpha1=0; p1=[1 tan(alpha1)]; p1=p1/norm(p1);%%%will not move
%% initial position & angle of mirror 2
alpha2=(y22-y12)/(x22-x12);%%%%%%%will move
p2=[1 tan(alpha2)]; p2=p2/norm(p2);

clear hh1 hh2 hvs1 hvs2 hhim hss poty potyy potrand  %%%% plot of mirror 2
    hh1=plot([min(Sx) max(Sx)],[p1(2)*min(Sx) p1(2)*max(Sx)]+y12,'r');
    hh2=plot([min(Sx) max(Sx)],[p2(2)*min(Sx) p2(2)*max(Sx)]+y22,'m');


%%% first overall plot
hh26=plot(plp(2),y22,'r+');
htt21=text(plp(2)+plwx/3,plwy/5,num2str(-10));
htt23=text(plp(2)+plwx/2,-plwy/8,' stop si < -9')
htt22=text(plp(2)+plwx/3,-plwy/5,num2str(+10));

htt25=text(plp(2)+5,y22,num2str(y22,4));

htt11=text(plp(1)-plwx/5,-plwy/5,num2str(-10));
htt13=text(plp(1)-plwx/2,-plwy/8,[' stop si < -9'])
htt12=text(plp(1)-plwx/5,+plwy/5,num2str(+10));
htt15=text(plp(1)-20,y12,num2str(y12,4));
set(htt15,'horizontalalignment','right')
hh16=plot(plp(1)-3,y12,'b+');

htt31=text(plp(1)-plwx/2, plp(4)+plwy/5,num2str(0));
htt32=text(plp(1)+plwx/2, plp(4)+plwy/5,num2str(+100));
htt35=text(plp(1),plp(4)+plwy/12,['phasedegre=' num2str(phasedegre,4)]);
%%%%%%%%%%%%%%%%%%%%%%%%%
j=0;%%to implement continuous fading

%%
xliim=get(gca,'xlim');yliim=get(gca,'ylim');  %%% to check window changes;
set(gca,'position',[0.08 0.07 0.9 0.89])
wpos=get(gca,'position');
pos2=get(hf2,'position');
%%% with these data, the formula from axis to window coordinate are
%xxx_screen=(wpos(1)+wpos(3)*(x-xliim(1))/(xliim(2)-xliim(1)))*(pos2(3))
%yyy_screen=(wpos(2)+wpos(4)*(y-yliim(1))/(yliim(2)-yliim(1)))*(pos2(4))

hold on;
%%%%%%% cursor of left side of mirror
xxlo=plp(1)-plwx/2;%/3;
xxlom=(wpos(1)+wpos(3)*(xxlo-xliim(1))/(xliim(2)-xliim(1)))*(pos2(3));
yylo=-plwy/6;
yylom=(wpos(2)+wpos(4)*(yylo-yliim(1))/(yliim(2)-yliim(1)))*(pos2(4));
yyhi=+plwy/6;
yyhim=(wpos(2)+wpos(4)*(yyhi-yliim(1))/(yliim(2)-yliim(1)))*(pos2(4));
poty=uicontrol(hf2,...
                'style','slider','min',-10,'max',10,...
                'position',[xxlom yylom 20 max(yyhim-yylom,21)],...
                'sliderstep',[0.001 0.01],...
                'value',y12,...
                'callback',(['y12=get(poty,''value'');']));


xxlo=plp(2)+plwx/3;xxlom=(wpos(1)+wpos(3)*(xxlo-xliim(1))/(xliim(2)-xliim(1)))*(pos2(3));
yylo=-plwy/6;      yylom=(wpos(2)+wpos(4)*(yylo-yliim(1))/(yliim(2)-yliim(1)))*(pos2(4));
yyhi=plwy/6;       yyhim=(wpos(2)+wpos(4)*(yyhi-yliim(1))/(yliim(2)-yliim(1)))*(pos2(4));

    %'position',[0.70*pos2(3) 0.44*pos2(4) 20 100],...
potyy=uicontrol(hf2,...
    'style','slider','min',-10,'max',10,...
    'position',[xxlom yylom 20 max(yyhim-yylom,21)],...
    'sliderstep',[0.001 0.01],...
    'value',y22,...
    'callback',(['y22=get(potyy,''value'');']));

xxlo=plp(1)-plwx*0.4;
xxlom=(wpos(1)+wpos(3)*(xxlo-xliim(1))/(xliim(2)-xliim(1)))*(pos2(3));
xxhi=plp(1)+plwx*0.48;
xxhim=(wpos(1)+wpos(3)*(xxhi-xliim(1))/(xliim(2)-xliim(1)))*(pos2(3));
yylo=plp(4)+plwy/7;
yylom=(wpos(2)+wpos(4)*(yylo-yliim(1))/(yliim(2)-yliim(1)))*(pos2(4));
%'position',[0.30*pos2(3) 0.88*pos2(4) 150 25],...
potrand=uicontrol(hf2,...
    'style','slider','min',0,'max',200,...
    'position',[xxlom yylom max(xxhim-xxlom,16)  15],...
    'sliderstep',[0.01 0.1],...
    'value',phasedegre,...
    'callback',(['phasedegre=get(potrand,''value'');']));
%%
            
while (y22>-9.1)&(y12>-9.1);%%%% so that it stops otherwise
    j=j+1;%%to implement continuous fading
    pos2new=get(hf2,'position');%%% get data to go from axis to window coordinates
    if (pos2new==pos2); flagnew=0; else flagnew=1; pos2=pos2new; end; %% detect window changes
    if flagnew;
        disp('flagnew')
    
        set(gca,'position',[0.08 0.07 0.9 0.89])
        wpos=get(gca,'position');
        pos2=get(hf2,'position');
        %%% with these data, the formula from axis to window coordinate are
        %xxx_screen=(wpos(1)+wpos(3)*(x-xliim(1))/(xliim(2)-xliim(1)))*(pos2(3))
        %yyy_screen=(wpos(2)+wpos(4)*(y-yliim(1))/(yliim(2)-yliim(1)))*(pos2(4))

        hold on;
        %%%%%%% cursor of left side of mirror
        xxlo=plp(1)-plwx/2;%/3;
        xxlom=(wpos(1)+wpos(3)*(xxlo-xliim(1))/(xliim(2)-xliim(1)))*(pos2(3));
        yylo=-plwy/6;
        yylom=(wpos(2)+wpos(4)*(yylo-yliim(1))/(yliim(2)-yliim(1)))*(pos2(4));
        yyhi=+plwy/6;
        yyhim=(wpos(2)+wpos(4)*(yyhi-yliim(1))/(yliim(2)-yliim(1)))*(pos2(4));


        if exist('poty');delete(poty);end;
        %'position',[xxlom yylom 20 max(yyhim-yylom,21)],...
        %'position',[0.30*pos2(3) 0.44*pos2(4) 20 100],...
        poty=uicontrol(hf2,...
            'style','slider','min',-10,'max',10,...
            'position',[xxlom yylom 20 max(yyhim-yylom,21)],...
            'sliderstep',[0.001 0.01],...
            'value',y12,...
            'callback',(['y12=get(poty,''value'');']));
    else
        y12=get(poty,'value');
    end;
    delete(hh16);delete(htt11);delete(htt12);delete(htt13);delete(htt15);
    
    %disp(100+y12);%%%%writing boundaries of mirror "screws" on the figure
    htt11=text(plp(1)-plwx/5,-plwy/5,num2str(-10));
    htt13=text(plp(1)-plwx*0.7,-plwy/8,' stop si < -9');
    htt12=text(plp(1)-plwx/5,+plwy/5,num2str(+10));
    %htt15=text(plp(1)-20,y12-5,num2str(y12,4));
    %set(htt15,'horizontalalignment','right')
    %set(htt15,'fontweight','bold');
    
    %hh16=plot(x12,y12,'b+');
    %%%prepare fpr write side of mirror
    if flagnew;
    xxlo=plp(2)+plwx/3;xxlom=(wpos(1)+wpos(3)*(xxlo-xliim(1))/(xliim(2)-xliim(1)))*(pos2(3));
    yylo=-plwy/6;      yylom=(wpos(2)+wpos(4)*(yylo-yliim(1))/(yliim(2)-yliim(1)))*(pos2(4));
    yyhi=plwy/6;       yyhim=(wpos(2)+wpos(4)*(yyhi-yliim(1))/(yliim(2)-yliim(1)))*(pos2(4));

        if exist('potyy');delete(potyy);end;
        %'position',[0.70*pos2(3) 0.44*pos2(4) 20 100],...
    potyy=uicontrol(hf2,...
        'style','slider','min',-10,'max',10,...
        'position',[xxlom yylom 20 max(yyhim-yylom,21)],...
        'sliderstep',[0.001 0.01],...
        'value',y22,...
        'callback',(['y22=get(potyy,''value'');']));
    else
        y22=get(potyy,'value');
    end;
    delete(hh26);delete(htt21);delete(htt22);delete(htt23);delete(htt25);
    %hh2=plot(50,y22,'r+');
    %disp(100+y22);
    %hh26=plot(plp(2),y22,'r+');
    htt21=text(plp(2)+plwx/3,plwy/5,num2str(-10));
    htt23=text(plp(2)+plwx/2,-plwy/8,' stop si < -9');
    htt22=text(plp(2)+plwx/3,-plwy/5,num2str(+10));
    
    %htt25=text(x22+20,y22-5,num2str(y22,4));
    %set(htt25,'fontweight','bold');
    
    if flagnew
        
    if exist('potrand');delete(potrand);end;
    xxlo=plp(1)-plwx*0.4;  
        xxlom=(wpos(1)+wpos(3)*(xxlo-xliim(1))/(xliim(2)-xliim(1)))*(pos2(3));
    xxhi=plp(1)+plwx*0.48; 
        xxhim=(wpos(1)+wpos(3)*(xxhi-xliim(1))/(xliim(2)-xliim(1)))*(pos2(3));
    yylo=plp(4)+plwy/7;      
        yylom=(wpos(2)+wpos(4)*(yylo-yliim(1))/(yliim(2)-yliim(1)))*(pos2(4));
    %'position',[0.30*pos2(3) 0.88*pos2(4) 150 25],...
    potrand=uicontrol(hf2,...
        'style','slider','min',0,'max',200,...
        'position',[xxlom yylom max(xxhim-xxlom,16)  15],...
        'sliderstep',[0.01 0.1],...
        'value',phasedegre,...
        'callback',(['phasedegre=get(potrand,''value'');']));
    else
        phasedegre=get(potrand,'value');
    end;
    delete(htt31);delete(htt32);delete(htt35);
    htt31=text(plp(1)-plwx/2, plp(4)+plwy/6,num2str(0));
    htt32=text(plp(1)+plwx/2, plp(4)+plwy/6,num2str(+200));
    htt35=text(plp(1),plp(4)+plwy/10,['phase relative (degr)=' num2str(phasedegre,4)]);
    set(htt35,'fontweight','bold');
    %%% pause(0.01);
    
    %%%%%%%%%%%% NOW OPTICAL CALCULATIONS %%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    alpha2=(y22-y12)/(x22-x12); %%%%mirror 2 angle and unit vector
    p2=[1 tan(alpha2)]; p2=p2/norm(p2);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% %%%% SOURCE POSITION
    %xs=plwx/20+sourcerand*rand;  ys=0.9*plp(4)+sourcerand*rand;    %%%% SOURCE POSITION
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% %%%% SOURCE POSITION
    xs=plwx/20  ;ys=40*plp(4);
    
    if Nss<Ns %%%%%%%%%%%%%%%% moyenne mobile (moving mean)
        xss=[xss xs];
        yss=[yss ys];
    else
        xss=[xss(2:Ns) xs];yss=[yss(2:Ns) ys];
    end;
    Nss=length(xss);
    
    disp([Nss,xs,ys])
    
    vs=[xs ys];%%%%%%%%% current source
    
    %%%% find its images   vs1, and vs2 (2 components each, x and y)
    vpar1=(vs*p1')*p1; % composante parallele  p1
    vper1=vs-(vs*p1')*p1; % composante perpendiculaire  p1
    vs1=vpar1-vper1;   %image
    
    vss=vs-[0 y12]; %%%vector from source to left edge at (0 y12) (y12 was called e0) 
    vpar2=(vss*p2')*p2; % composante parallele  p2
    vper2=vss-(vss*p2')*p2; % composante perpendiculaire  p2
    vss2=vpar2-vper2;%%% vector to image 2 as referenced from (0, y12) 
    vs2=vss2+[0 y12];  % back to standard coordinate
    
    
    d1=sqrt((X-vs1(1)).^2+(Y-vs1(2)).^2);%($) il suffirait de mettre ici Y(N-2:N+2), comprenant lepoint y=0....
    d2=sqrt((X-vs2(1)).^2+(Y-vs2(2)).^2);%($) il suffirait de mettre ici Y(N-2:N+2), comprenant lepoint y=0...
   %($)?  ou tout simplement Y=0
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%ORDER AT Y=0 plane
    
    
    p_chroma_m1=(1./(lambdas).')*(sqrt((Sx-vs1(1)).^2+(0-vs1(2)).^2)-sqrt((Sx-vs2(1)).^2+(0-vs2(2)).^2));
    %p_chroma_m1=p_chroma_m1+(0.3*lambdas+10*(lambdas.^2-lambda^2))'*ones(1,length(Sx)) ; %depahasage separatrice mim
    pha=(d2-d1)*(2*pi/lambda)+(pi*phasedegre/180);
    
     figure(3); %%%%%%%%%%%%%%%%%%%%%for COLOR plots
         colr=exp(-(lambdas-0.62).^2/0.005);  %RGB channels for each lambda "cheap CIE table")
         colv=exp(-(lambdas-0.53).^2/0.005);
         colb=exp(-(lambdas-0.45).^2/0.005);
     Ichro=1+cos(2*pi*p_chroma_m1+(pi*phasedegre/180));%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% MAIN FORMULA, sign change for dephasing pi. 
     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% MAIN FORMULA, (...) 
     subplot(4,1,1) ; hchro1=plot(Sx,p_chroma_m1.');
     ylabel('ordre p');title('ordre d''interfrence                                                    ');
     grid on
     for jjchro=1:length(lambdas); set(hchro1(jjchro),'color',[colr(jjchro) colv(jjchro) colb(jjchro)]); end
     subplot(4,1,2) ; hchro=plot(Sx,Ichro');%1+cos(2*pi*p_chroma_m1.'));
          ylabel('intensit');title('contribution de chaque lment du spectre                                                    ');
          grid on;
     for jjchro=1:length(lambdas); set(hchro(jjchro),'color',[colr(jjchro) colv(jjchro) colb(jjchro)]); end
     subplot(4,1,3) ; 
     
     C(:,:,1)=0.5*Ichro.*(colr'*ones(1,length(Sx)));
     C(:,:,2)=0.5*Ichro.*(colv'*ones(1,length(Sx)));
     C(:,:,3)=0.5*Ichro.*(colb'*ones(1,length(Sx)));
     image(Sx,lambdas,0.8*C+0.2);
     ylabel('lambda(microns)');title('sortie disperse par un prisme                                          ');
     %image(Sx,lambdas,32*(1+cos(2*pi*p_chroma_m1)));
     %%image(Sx,lambdas,32*(1+cos(2*pi*p_chroma_m1)));
     %CC1=sum(C)./length(lambdas);CC2=min(2*sum(C),1)./length(lambdas);
     CC1=min(2.3*sum(C)./length(lambdas),1);
     CC2=min(2.6*sum(C)./length(lambdas),1);
     CC3=min(2.85*sum(C)./length(lambdas),1);
     CC4=min(2.95*sum(C)./length(lambdas),1);
     CC(1,:,:)=CC1;CC(2,:,:)=CC2;CC(3,:,:)=CC3;CC(4,:,:)=CC4;
     CC(8,:,:)=CC1;CC(7,:,:)=CC2;CC(6,:,:)=CC3;CC(5,:,:)=CC4;
     %CC=min(CC,1);
     hhs4=subplot(4,1,4) ; image(Sx,[0 3],0.02+0.98*CC);
     set(hhs4,'YTickLabel',[])
     xlabel('position sur le miroir (microns)'); ylabel('R+G+B'); title('ce que voit l''oeil                                                         ')
     
     hh3=get(gcf,'children');
     for jjh=1:4; 
         hh3t=get(hh3(jjh),'title'); 
         set(hh3t,'fontweight', 'bold','fontangle','italic');
         ppp=get(hh3t,'position');
         if jjh==1; set(hh3t,'position',ppp+[0 +0.2 0]);end;
         if jjh==2; set(hh3t,'position',ppp+[0 +0.02 0]);end;
         if jjh==3; set(hh3t,'position',ppp+[0 -0.12 0]);end;
         %set(hh3t,'margin', 0.1);
     end;
     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     figure(4);cla;plot(lambdas,colr,'r',lambdas,colv,'g',lambdas,colb,'b');
     ylabel('intensit partielle bricole');xlabel('lambda(micron)');
     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%     
    figure(2);
    
    taux=0.04;ctaux=1-taux;%%%%%%%%%%% refreshing rate
    Itot=ctaux*Itot+taux*(1+cos(pha));  %%% partial refreshing at rate "taux"
                %($) restetreindre ce calcul de pha  une petite partie, ou
                %carrment renoncer  mettre un contenu de franges figure 2
    Imax=ctaux*Imax+taux*(2);           %%% easy calculation of corresponding normalisation
                                                    %%% (2) is the maximum of 1 +cos(...)
    Iplot=Itot*(64/Imax);                %%% image is nomralised to 64 (matlab std)
    %zoom on;
    %colormap('gray')
    colormap([0.2*linspace(0,1,64);linspace(0,1,64);0.2*linspace(0,1,64)]')%%%%
    %%%%colors RGB should be weighted by mean(colr) mean(colv) mean(colb)
    %%%%renormalized...%%%%% (to be done)
    if rem(j,1)==0;
        if exist('hhim') ; delete(hhim); end; 
        hhim=image(Sx,[-sc*4 sc*4],Iplot);
        if exist('hss') ; delete(hss); end;       
        hss=plot(xss,yss,'b+');
        set(hss,'linewidth',2);
        if exist('hvs1') ; delete(hvs1);end;
        hvs1=plot(vs1(1),vs1(2),'mo');set(hvs1,'linewidth',2);
        if exist('hvs2') ; delete(hvs2); end; 
        hvs2=plot(vs2(1),vs2(2),'co');set(hvs2,'linewidth',2);
        delete(hh1);delete(hh2);
         hh1=plot([min(SSx) max(SSx)],[p1(2)*min(SSx) p1(2)*max(SSx)]+0,'r');%y11=0;
         hh2=plot([min(SSx) max(SSx)],[p2(2)*min(SSx) p2(2)*max(SSx)]+y12,'m');
         hh16=plot(x12,y12,'b+');
         hh26=plot(plp(2),y22,'r+');
         htt25=text(x22+20,y22+45,num2str(y22,4));
          set(htt25,'fontweight','bold');
         htt15=text(plp(1)-20,y12+45,num2str(y12,4));
          set(htt15,'horizontalalignment','right')
          set(htt15,'fontweight','bold');
    
         %%%
        %axis([0 4*sc -4*sc 4*sc])
        %%%
        %axis('equal')
        xlabel('x, microns');ylabel('y, microns');
        title([num2str(Nss) '/' num2str(Ns) '   ' num2str(j)])
        pause(0.001);
    end;
end;